/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SalesforceControllerActionAttributeRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SalesforceControllerActionAttributeRequest{}

// SalesforceControllerActionAttributeRequest struct for SalesforceControllerActionAttributeRequest
type SalesforceControllerActionAttributeRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	Instance   *string `json:"instance,omitempty"`
	ApiVersion *string `json:"apiVersion,omitempty"`
	Object     *string `json:"object,omitempty"`
}

// NewSalesforceControllerActionAttributeRequest instantiates a new SalesforceControllerActionAttributeRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSalesforceControllerActionAttributeRequest() *SalesforceControllerActionAttributeRequest {
	this := SalesforceControllerActionAttributeRequest{}
	return &this
}

// NewSalesforceControllerActionAttributeRequestWithDefaults instantiates a new SalesforceControllerActionAttributeRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSalesforceControllerActionAttributeRequestWithDefaults() *SalesforceControllerActionAttributeRequest {
	this := SalesforceControllerActionAttributeRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *SalesforceControllerActionAttributeRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionAttributeRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *SalesforceControllerActionAttributeRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *SalesforceControllerActionAttributeRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetInstance returns the Instance field value if set, zero value otherwise.
func (o *SalesforceControllerActionAttributeRequest) GetInstance() string {
	if o == nil || IsNil(o.Instance) {
		var ret string
		return ret
	}
	return *o.Instance
}

// GetInstanceOk returns a tuple with the Instance field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionAttributeRequest) GetInstanceOk() (*string, bool) {
	if o == nil || IsNil(o.Instance) {
		return nil, false
	}
	return o.Instance, true
}

// HasInstance returns a boolean if a field has been set.
func (o *SalesforceControllerActionAttributeRequest) HasInstance() bool {
	if o != nil && !IsNil(o.Instance) {
		return true
	}

	return false
}

// SetInstance gets a reference to the given string and assigns it to the Instance field.
func (o *SalesforceControllerActionAttributeRequest) SetInstance(v string) {
	o.Instance = &v
}

// GetApiVersion returns the ApiVersion field value if set, zero value otherwise.
func (o *SalesforceControllerActionAttributeRequest) GetApiVersion() string {
	if o == nil || IsNil(o.ApiVersion) {
		var ret string
		return ret
	}
	return *o.ApiVersion
}

// GetApiVersionOk returns a tuple with the ApiVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionAttributeRequest) GetApiVersionOk() (*string, bool) {
	if o == nil || IsNil(o.ApiVersion) {
		return nil, false
	}
	return o.ApiVersion, true
}

// HasApiVersion returns a boolean if a field has been set.
func (o *SalesforceControllerActionAttributeRequest) HasApiVersion() bool {
	if o != nil && !IsNil(o.ApiVersion) {
		return true
	}

	return false
}

// SetApiVersion gets a reference to the given string and assigns it to the ApiVersion field.
func (o *SalesforceControllerActionAttributeRequest) SetApiVersion(v string) {
	o.ApiVersion = &v
}

// GetObject returns the Object field value if set, zero value otherwise.
func (o *SalesforceControllerActionAttributeRequest) GetObject() string {
	if o == nil || IsNil(o.Object) {
		var ret string
		return ret
	}
	return *o.Object
}

// GetObjectOk returns a tuple with the Object field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SalesforceControllerActionAttributeRequest) GetObjectOk() (*string, bool) {
	if o == nil || IsNil(o.Object) {
		return nil, false
	}
	return o.Object, true
}

// HasObject returns a boolean if a field has been set.
func (o *SalesforceControllerActionAttributeRequest) HasObject() bool {
	if o != nil && !IsNil(o.Object) {
		return true
	}

	return false
}

// SetObject gets a reference to the given string and assigns it to the Object field.
func (o *SalesforceControllerActionAttributeRequest) SetObject(v string) {
	o.Object = &v
}

func (o SalesforceControllerActionAttributeRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SalesforceControllerActionAttributeRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Instance) {
		toSerialize["instance"] = o.Instance
	}
	if !IsNil(o.ApiVersion) {
		toSerialize["apiVersion"] = o.ApiVersion
	}
	if !IsNil(o.Object) {
		toSerialize["object"] = o.Object
	}
	return toSerialize, nil
}

type NullableSalesforceControllerActionAttributeRequest struct {
	value *SalesforceControllerActionAttributeRequest
	isSet bool
}

func (v NullableSalesforceControllerActionAttributeRequest) Get() *SalesforceControllerActionAttributeRequest {
	return v.value
}

func (v *NullableSalesforceControllerActionAttributeRequest) Set(val *SalesforceControllerActionAttributeRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSalesforceControllerActionAttributeRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSalesforceControllerActionAttributeRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSalesforceControllerActionAttributeRequest(val *SalesforceControllerActionAttributeRequest) *NullableSalesforceControllerActionAttributeRequest {
	return &NullableSalesforceControllerActionAttributeRequest{value: val, isSet: true}
}

func (v NullableSalesforceControllerActionAttributeRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSalesforceControllerActionAttributeRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
